/* dictionary.c generated by valac 0.56.3, the Vala compiler
 * generated from dictionary.vala, do not modify */

/* 
 * Copyright (C) 2011-2014 Daiki Ueno <ueno@gnu.org>
 * Copyright (C) 2011-2014 Red Hat, Inc.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
 * 02110-1301, USA.
 */

#include "libutil.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <json-glib/json-glib.h>
#include <config.h>
#include <glib-object.h>
#include <gee.h>
#include <gio/gio.h>
#include <glib/gstdio.h>

enum  {
	DICTIONARY_METADATA_0_PROPERTY,
	DICTIONARY_METADATA_ID_PROPERTY,
	DICTIONARY_METADATA_FILENAME_PROPERTY,
	DICTIONARY_METADATA_NAME_PROPERTY,
	DICTIONARY_METADATA_DESCRIPTION_PROPERTY,
	DICTIONARY_METADATA_ENCODING_PROPERTY,
	DICTIONARY_METADATA_DEFAULT_ENABLED_PROPERTY,
	DICTIONARY_METADATA_NUM_PROPERTIES
};
static GParamSpec* dictionary_metadata_properties[DICTIONARY_METADATA_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	DICTIONARY_REGISTRY_0_PROPERTY,
	DICTIONARY_REGISTRY_NUM_PROPERTIES
};
static GParamSpec* dictionary_registry_properties[DICTIONARY_REGISTRY_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define __vala_JsonNode_free0(var) ((var == NULL) ? NULL : (var = (_vala_JsonNode_free (var), NULL)))
#define _json_object_unref0(var) ((var == NULL) ? NULL : (var = (json_object_unref (var), NULL)))
#define _json_array_unref0(var) ((var == NULL) ? NULL : (var = (json_array_unref (var), NULL)))

struct _DictionaryMetadataPrivate {
	gchar* _id;
	gchar* _filename;
	gchar* _name;
	gchar* _description;
	gchar* _encoding;
	gboolean _default_enabled;
};

struct _DictionaryRegistryPrivate {
	GeeMap* available_metadata;
	GeeList* available;
};

static gint DictionaryMetadata_private_offset;
static gpointer dictionary_metadata_parent_class = NULL;
static gint DictionaryRegistry_private_offset;
static gpointer dictionary_registry_parent_class = NULL;

static void dictionary_metadata_finalize (GObject * obj);
static GType dictionary_metadata_get_type_once (void);
static void _vala_dictionary_metadata_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec);
static void _vala_dictionary_metadata_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec);
static void dictionary_registry_load_metadata_from_stream (DictionaryRegistry* self,
                                                    GInputStream* stream);
static JsonNode* _vala_JsonNode_copy (JsonNode* self);
static void _vala_JsonNode_free (JsonNode* self);
static void dictionary_registry_finalize (GObject * obj);
static GType dictionary_registry_get_type_once (void);

static inline gpointer
dictionary_metadata_get_instance_private (DictionaryMetadata* self)
{
	return G_STRUCT_MEMBER_P (self, DictionaryMetadata_private_offset);
}

DictionaryMetadata*
dictionary_metadata_construct_from_json_object (GType object_type,
                                                JsonObject* object)
{
	DictionaryMetadata * self = NULL;
	gchar* id = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* filename = NULL;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* name = NULL;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* description = NULL;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	gboolean default_enabled = FALSE;
	gchar* encoding = NULL;
	gchar* _tmp8_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	const gchar* _tmp15_;
	const gchar* _tmp16_;
	const gchar* _tmp17_;
#line 31 "dictionary.vala"
	g_return_val_if_fail (object != NULL, NULL);
#line 32 "dictionary.vala"
	_tmp0_ = json_object_get_string_member (object, "id");
#line 32 "dictionary.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 32 "dictionary.vala"
	id = _tmp1_;
#line 33 "dictionary.vala"
	_tmp2_ = json_object_get_string_member (object, "filename");
#line 33 "dictionary.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 33 "dictionary.vala"
	filename = _tmp3_;
#line 34 "dictionary.vala"
	_tmp4_ = json_object_get_string_member (object, "name");
#line 34 "dictionary.vala"
	_tmp5_ = g_strdup (_tmp4_);
#line 34 "dictionary.vala"
	name = _tmp5_;
#line 35 "dictionary.vala"
	_tmp6_ = json_object_get_string_member (object, "description");
#line 35 "dictionary.vala"
	_tmp7_ = g_strdup (_tmp6_);
#line 35 "dictionary.vala"
	description = _tmp7_;
#line 37 "dictionary.vala"
	default_enabled = FALSE;
#line 38 "dictionary.vala"
	if (json_object_has_member (object, "default_enabled")) {
#line 39 "dictionary.vala"
		default_enabled = json_object_get_boolean_member (object, "default_enabled");
#line 160 "dictionary.c"
	}
#line 41 "dictionary.vala"
	_tmp8_ = g_strdup ("EUC-JP");
#line 41 "dictionary.vala"
	encoding = _tmp8_;
#line 42 "dictionary.vala"
	if (json_object_has_member (object, "encoding")) {
#line 168 "dictionary.c"
		const gchar* _tmp9_;
		gchar* _tmp10_;
#line 43 "dictionary.vala"
		_tmp9_ = json_object_get_string_member (object, "encoding");
#line 43 "dictionary.vala"
		_tmp10_ = g_strdup (_tmp9_);
#line 43 "dictionary.vala"
		_g_free0 (encoding);
#line 43 "dictionary.vala"
		encoding = _tmp10_;
#line 179 "dictionary.c"
	}
#line 46 "dictionary.vala"
	_tmp11_ = id;
#line 46 "dictionary.vala"
	_tmp12_ = filename;
#line 46 "dictionary.vala"
	_tmp13_ = g_build_filename (SKKDICDIR, _tmp12_, NULL);
#line 46 "dictionary.vala"
	_tmp14_ = _tmp13_;
#line 46 "dictionary.vala"
	_tmp15_ = name;
#line 46 "dictionary.vala"
	_tmp16_ = description;
#line 46 "dictionary.vala"
	_tmp17_ = encoding;
#line 46 "dictionary.vala"
	self = (DictionaryMetadata*) g_object_new (object_type, "id", _tmp11_, "filename", _tmp14_, "name", _tmp15_, "description", _tmp16_, "default-enabled", default_enabled, "encoding", _tmp17_, NULL);
#line 46 "dictionary.vala"
	_g_free0 (_tmp14_);
#line 31 "dictionary.vala"
	_g_free0 (encoding);
#line 31 "dictionary.vala"
	_g_free0 (description);
#line 31 "dictionary.vala"
	_g_free0 (name);
#line 31 "dictionary.vala"
	_g_free0 (filename);
#line 31 "dictionary.vala"
	_g_free0 (id);
#line 31 "dictionary.vala"
	return self;
#line 211 "dictionary.c"
}

DictionaryMetadata*
dictionary_metadata_new_from_json_object (JsonObject* object)
{
#line 31 "dictionary.vala"
	return dictionary_metadata_construct_from_json_object (TYPE_DICTIONARY_METADATA, object);
#line 219 "dictionary.c"
}

DictionaryMetadata*
dictionary_metadata_construct (GType object_type)
{
	DictionaryMetadata * self = NULL;
#line 22 "dictionary.vala"
	self = (DictionaryMetadata*) g_object_new (object_type, NULL);
#line 22 "dictionary.vala"
	return self;
#line 230 "dictionary.c"
}

DictionaryMetadata*
dictionary_metadata_new (void)
{
#line 22 "dictionary.vala"
	return dictionary_metadata_construct (TYPE_DICTIONARY_METADATA);
#line 238 "dictionary.c"
}

const gchar*
dictionary_metadata_get_id (DictionaryMetadata* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 23 "dictionary.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 23 "dictionary.vala"
	_tmp0_ = self->priv->_id;
#line 23 "dictionary.vala"
	result = _tmp0_;
#line 23 "dictionary.vala"
	return result;
#line 254 "dictionary.c"
}

void
dictionary_metadata_set_id (DictionaryMetadata* self,
                            const gchar* value)
{
	gchar* old_value;
#line 23 "dictionary.vala"
	g_return_if_fail (self != NULL);
#line 23 "dictionary.vala"
	old_value = dictionary_metadata_get_id (self);
#line 23 "dictionary.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 268 "dictionary.c"
		gchar* _tmp0_;
#line 23 "dictionary.vala"
		_tmp0_ = g_strdup (value);
#line 23 "dictionary.vala"
		_g_free0 (self->priv->_id);
#line 23 "dictionary.vala"
		self->priv->_id = _tmp0_;
#line 23 "dictionary.vala"
		g_object_notify_by_pspec ((GObject *) self, dictionary_metadata_properties[DICTIONARY_METADATA_ID_PROPERTY]);
#line 278 "dictionary.c"
	}
}

const gchar*
dictionary_metadata_get_filename (DictionaryMetadata* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 24 "dictionary.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 24 "dictionary.vala"
	_tmp0_ = self->priv->_filename;
#line 24 "dictionary.vala"
	result = _tmp0_;
#line 24 "dictionary.vala"
	return result;
#line 295 "dictionary.c"
}

void
dictionary_metadata_set_filename (DictionaryMetadata* self,
                                  const gchar* value)
{
	gchar* old_value;
#line 24 "dictionary.vala"
	g_return_if_fail (self != NULL);
#line 24 "dictionary.vala"
	old_value = dictionary_metadata_get_filename (self);
#line 24 "dictionary.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 309 "dictionary.c"
		gchar* _tmp0_;
#line 24 "dictionary.vala"
		_tmp0_ = g_strdup (value);
#line 24 "dictionary.vala"
		_g_free0 (self->priv->_filename);
#line 24 "dictionary.vala"
		self->priv->_filename = _tmp0_;
#line 24 "dictionary.vala"
		g_object_notify_by_pspec ((GObject *) self, dictionary_metadata_properties[DICTIONARY_METADATA_FILENAME_PROPERTY]);
#line 319 "dictionary.c"
	}
}

const gchar*
dictionary_metadata_get_name (DictionaryMetadata* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 25 "dictionary.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 25 "dictionary.vala"
	_tmp0_ = self->priv->_name;
#line 25 "dictionary.vala"
	result = _tmp0_;
#line 25 "dictionary.vala"
	return result;
#line 336 "dictionary.c"
}

void
dictionary_metadata_set_name (DictionaryMetadata* self,
                              const gchar* value)
{
	gchar* old_value;
#line 25 "dictionary.vala"
	g_return_if_fail (self != NULL);
#line 25 "dictionary.vala"
	old_value = dictionary_metadata_get_name (self);
#line 25 "dictionary.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 350 "dictionary.c"
		gchar* _tmp0_;
#line 25 "dictionary.vala"
		_tmp0_ = g_strdup (value);
#line 25 "dictionary.vala"
		_g_free0 (self->priv->_name);
#line 25 "dictionary.vala"
		self->priv->_name = _tmp0_;
#line 25 "dictionary.vala"
		g_object_notify_by_pspec ((GObject *) self, dictionary_metadata_properties[DICTIONARY_METADATA_NAME_PROPERTY]);
#line 360 "dictionary.c"
	}
}

const gchar*
dictionary_metadata_get_description (DictionaryMetadata* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 26 "dictionary.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 26 "dictionary.vala"
	_tmp0_ = self->priv->_description;
#line 26 "dictionary.vala"
	result = _tmp0_;
#line 26 "dictionary.vala"
	return result;
#line 377 "dictionary.c"
}

void
dictionary_metadata_set_description (DictionaryMetadata* self,
                                     const gchar* value)
{
	gchar* old_value;
#line 26 "dictionary.vala"
	g_return_if_fail (self != NULL);
#line 26 "dictionary.vala"
	old_value = dictionary_metadata_get_description (self);
#line 26 "dictionary.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 391 "dictionary.c"
		gchar* _tmp0_;
#line 26 "dictionary.vala"
		_tmp0_ = g_strdup (value);
#line 26 "dictionary.vala"
		_g_free0 (self->priv->_description);
#line 26 "dictionary.vala"
		self->priv->_description = _tmp0_;
#line 26 "dictionary.vala"
		g_object_notify_by_pspec ((GObject *) self, dictionary_metadata_properties[DICTIONARY_METADATA_DESCRIPTION_PROPERTY]);
#line 401 "dictionary.c"
	}
}

const gchar*
dictionary_metadata_get_encoding (DictionaryMetadata* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 28 "dictionary.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 28 "dictionary.vala"
	_tmp0_ = self->priv->_encoding;
#line 28 "dictionary.vala"
	result = _tmp0_;
#line 28 "dictionary.vala"
	return result;
#line 418 "dictionary.c"
}

void
dictionary_metadata_set_encoding (DictionaryMetadata* self,
                                  const gchar* value)
{
	gchar* old_value;
#line 28 "dictionary.vala"
	g_return_if_fail (self != NULL);
#line 28 "dictionary.vala"
	old_value = dictionary_metadata_get_encoding (self);
#line 28 "dictionary.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 432 "dictionary.c"
		gchar* _tmp0_;
#line 28 "dictionary.vala"
		_tmp0_ = g_strdup (value);
#line 28 "dictionary.vala"
		_g_free0 (self->priv->_encoding);
#line 28 "dictionary.vala"
		self->priv->_encoding = _tmp0_;
#line 28 "dictionary.vala"
		g_object_notify_by_pspec ((GObject *) self, dictionary_metadata_properties[DICTIONARY_METADATA_ENCODING_PROPERTY]);
#line 442 "dictionary.c"
	}
}

gboolean
dictionary_metadata_get_default_enabled (DictionaryMetadata* self)
{
	gboolean result;
#line 29 "dictionary.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 29 "dictionary.vala"
	result = self->priv->_default_enabled;
#line 29 "dictionary.vala"
	return result;
#line 456 "dictionary.c"
}

void
dictionary_metadata_set_default_enabled (DictionaryMetadata* self,
                                         gboolean value)
{
	gboolean old_value;
#line 29 "dictionary.vala"
	g_return_if_fail (self != NULL);
#line 29 "dictionary.vala"
	old_value = dictionary_metadata_get_default_enabled (self);
#line 29 "dictionary.vala"
	if (old_value != value) {
#line 29 "dictionary.vala"
		self->priv->_default_enabled = value;
#line 29 "dictionary.vala"
		g_object_notify_by_pspec ((GObject *) self, dictionary_metadata_properties[DICTIONARY_METADATA_DEFAULT_ENABLED_PROPERTY]);
#line 474 "dictionary.c"
	}
}

static void
dictionary_metadata_class_init (DictionaryMetadataClass * klass,
                                gpointer klass_data)
{
#line 22 "dictionary.vala"
	dictionary_metadata_parent_class = g_type_class_peek_parent (klass);
#line 22 "dictionary.vala"
	g_type_class_adjust_private_offset (klass, &DictionaryMetadata_private_offset);
#line 22 "dictionary.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_dictionary_metadata_get_property;
#line 22 "dictionary.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_dictionary_metadata_set_property;
#line 22 "dictionary.vala"
	G_OBJECT_CLASS (klass)->finalize = dictionary_metadata_finalize;
#line 22 "dictionary.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DICTIONARY_METADATA_ID_PROPERTY, dictionary_metadata_properties[DICTIONARY_METADATA_ID_PROPERTY] = g_param_spec_string ("id", "id", "id", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 22 "dictionary.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DICTIONARY_METADATA_FILENAME_PROPERTY, dictionary_metadata_properties[DICTIONARY_METADATA_FILENAME_PROPERTY] = g_param_spec_string ("filename", "filename", "filename", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 22 "dictionary.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DICTIONARY_METADATA_NAME_PROPERTY, dictionary_metadata_properties[DICTIONARY_METADATA_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 22 "dictionary.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DICTIONARY_METADATA_DESCRIPTION_PROPERTY, dictionary_metadata_properties[DICTIONARY_METADATA_DESCRIPTION_PROPERTY] = g_param_spec_string ("description", "description", "description", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 22 "dictionary.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DICTIONARY_METADATA_ENCODING_PROPERTY, dictionary_metadata_properties[DICTIONARY_METADATA_ENCODING_PROPERTY] = g_param_spec_string ("encoding", "encoding", "encoding", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 22 "dictionary.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DICTIONARY_METADATA_DEFAULT_ENABLED_PROPERTY, dictionary_metadata_properties[DICTIONARY_METADATA_DEFAULT_ENABLED_PROPERTY] = g_param_spec_boolean ("default-enabled", "default-enabled", "default-enabled", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 504 "dictionary.c"
}

static void
dictionary_metadata_instance_init (DictionaryMetadata * self,
                                   gpointer klass)
{
	gchar* _tmp0_;
#line 22 "dictionary.vala"
	self->priv = dictionary_metadata_get_instance_private (self);
#line 28 "dictionary.vala"
	_tmp0_ = g_strdup ("EUC-JP");
#line 28 "dictionary.vala"
	self->priv->_encoding = _tmp0_;
#line 29 "dictionary.vala"
	self->priv->_default_enabled = FALSE;
#line 520 "dictionary.c"
}

static void
dictionary_metadata_finalize (GObject * obj)
{
	DictionaryMetadata * self;
#line 22 "dictionary.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_DICTIONARY_METADATA, DictionaryMetadata);
#line 23 "dictionary.vala"
	_g_free0 (self->priv->_id);
#line 24 "dictionary.vala"
	_g_free0 (self->priv->_filename);
#line 25 "dictionary.vala"
	_g_free0 (self->priv->_name);
#line 26 "dictionary.vala"
	_g_free0 (self->priv->_description);
#line 28 "dictionary.vala"
	_g_free0 (self->priv->_encoding);
#line 22 "dictionary.vala"
	G_OBJECT_CLASS (dictionary_metadata_parent_class)->finalize (obj);
#line 541 "dictionary.c"
}

static GType
dictionary_metadata_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DictionaryMetadataClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) dictionary_metadata_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DictionaryMetadata), 0, (GInstanceInitFunc) dictionary_metadata_instance_init, NULL };
	GType dictionary_metadata_type_id;
	dictionary_metadata_type_id = g_type_register_static (G_TYPE_OBJECT, "DictionaryMetadata", &g_define_type_info, 0);
	DictionaryMetadata_private_offset = g_type_add_instance_private (dictionary_metadata_type_id, sizeof (DictionaryMetadataPrivate));
	return dictionary_metadata_type_id;
}

GType
dictionary_metadata_get_type (void)
{
	static volatile gsize dictionary_metadata_type_id__once = 0;
	if (g_once_init_enter (&dictionary_metadata_type_id__once)) {
		GType dictionary_metadata_type_id;
		dictionary_metadata_type_id = dictionary_metadata_get_type_once ();
		g_once_init_leave (&dictionary_metadata_type_id__once, dictionary_metadata_type_id);
	}
	return dictionary_metadata_type_id__once;
}

static void
_vala_dictionary_metadata_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec)
{
	DictionaryMetadata * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_DICTIONARY_METADATA, DictionaryMetadata);
#line 22 "dictionary.vala"
	switch (property_id) {
#line 22 "dictionary.vala"
		case DICTIONARY_METADATA_ID_PROPERTY:
#line 22 "dictionary.vala"
		g_value_set_string (value, dictionary_metadata_get_id (self));
#line 22 "dictionary.vala"
		break;
#line 22 "dictionary.vala"
		case DICTIONARY_METADATA_FILENAME_PROPERTY:
#line 22 "dictionary.vala"
		g_value_set_string (value, dictionary_metadata_get_filename (self));
#line 22 "dictionary.vala"
		break;
#line 22 "dictionary.vala"
		case DICTIONARY_METADATA_NAME_PROPERTY:
#line 22 "dictionary.vala"
		g_value_set_string (value, dictionary_metadata_get_name (self));
#line 22 "dictionary.vala"
		break;
#line 22 "dictionary.vala"
		case DICTIONARY_METADATA_DESCRIPTION_PROPERTY:
#line 22 "dictionary.vala"
		g_value_set_string (value, dictionary_metadata_get_description (self));
#line 22 "dictionary.vala"
		break;
#line 22 "dictionary.vala"
		case DICTIONARY_METADATA_ENCODING_PROPERTY:
#line 22 "dictionary.vala"
		g_value_set_string (value, dictionary_metadata_get_encoding (self));
#line 22 "dictionary.vala"
		break;
#line 22 "dictionary.vala"
		case DICTIONARY_METADATA_DEFAULT_ENABLED_PROPERTY:
#line 22 "dictionary.vala"
		g_value_set_boolean (value, dictionary_metadata_get_default_enabled (self));
#line 22 "dictionary.vala"
		break;
#line 612 "dictionary.c"
		default:
#line 22 "dictionary.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "dictionary.vala"
		break;
#line 618 "dictionary.c"
	}
}

static void
_vala_dictionary_metadata_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec)
{
	DictionaryMetadata * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_DICTIONARY_METADATA, DictionaryMetadata);
#line 22 "dictionary.vala"
	switch (property_id) {
#line 22 "dictionary.vala"
		case DICTIONARY_METADATA_ID_PROPERTY:
#line 22 "dictionary.vala"
		dictionary_metadata_set_id (self, g_value_get_string (value));
#line 22 "dictionary.vala"
		break;
#line 22 "dictionary.vala"
		case DICTIONARY_METADATA_FILENAME_PROPERTY:
#line 22 "dictionary.vala"
		dictionary_metadata_set_filename (self, g_value_get_string (value));
#line 22 "dictionary.vala"
		break;
#line 22 "dictionary.vala"
		case DICTIONARY_METADATA_NAME_PROPERTY:
#line 22 "dictionary.vala"
		dictionary_metadata_set_name (self, g_value_get_string (value));
#line 22 "dictionary.vala"
		break;
#line 22 "dictionary.vala"
		case DICTIONARY_METADATA_DESCRIPTION_PROPERTY:
#line 22 "dictionary.vala"
		dictionary_metadata_set_description (self, g_value_get_string (value));
#line 22 "dictionary.vala"
		break;
#line 22 "dictionary.vala"
		case DICTIONARY_METADATA_ENCODING_PROPERTY:
#line 22 "dictionary.vala"
		dictionary_metadata_set_encoding (self, g_value_get_string (value));
#line 22 "dictionary.vala"
		break;
#line 22 "dictionary.vala"
		case DICTIONARY_METADATA_DEFAULT_ENABLED_PROPERTY:
#line 22 "dictionary.vala"
		dictionary_metadata_set_default_enabled (self, g_value_get_boolean (value));
#line 22 "dictionary.vala"
		break;
#line 668 "dictionary.c"
		default:
#line 22 "dictionary.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "dictionary.vala"
		break;
#line 674 "dictionary.c"
	}
}

static inline gpointer
dictionary_registry_get_instance_private (DictionaryRegistry* self)
{
	return G_STRUCT_MEMBER_P (self, DictionaryRegistry_private_offset);
}

static JsonNode*
_vala_JsonNode_copy (JsonNode* self)
{
#line 68 "dictionary.vala"
	return g_boxed_copy (json_node_get_type (), self);
#line 689 "dictionary.c"
}

static gpointer
__vala_JsonNode_copy0 (gpointer self)
{
#line 68 "dictionary.vala"
	return self ? _vala_JsonNode_copy (self) : NULL;
#line 697 "dictionary.c"
}

static gpointer
_json_array_ref0 (gpointer self)
{
#line 73 "dictionary.vala"
	return self ? json_array_ref (self) : NULL;
#line 705 "dictionary.c"
}

static void
_vala_JsonNode_free (JsonNode* self)
{
#line 80 "dictionary.vala"
	g_boxed_free (json_node_get_type (), self);
#line 713 "dictionary.c"
}

static gpointer
_json_object_ref0 (gpointer self)
{
#line 83 "dictionary.vala"
	return self ? json_object_ref (self) : NULL;
#line 721 "dictionary.c"
}

static void
dictionary_registry_load_metadata_from_stream (DictionaryRegistry* self,
                                               GInputStream* stream)
{
	JsonParser* parser = NULL;
	JsonParser* _tmp0_;
	JsonNode* root = NULL;
	JsonNode* _tmp2_;
	JsonNode* _tmp3_;
	JsonArray* array = NULL;
	JsonArray* _tmp4_;
	JsonArray* _tmp5_;
	GError* _inner_error0_ = NULL;
#line 60 "dictionary.vala"
	g_return_if_fail (self != NULL);
#line 60 "dictionary.vala"
	g_return_if_fail (stream != NULL);
#line 61 "dictionary.vala"
	_tmp0_ = json_parser_new ();
#line 61 "dictionary.vala"
	parser = _tmp0_;
#line 745 "dictionary.c"
	{
#line 63 "dictionary.vala"
		json_parser_load_from_stream (parser, stream, NULL, &_inner_error0_);
#line 63 "dictionary.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 751 "dictionary.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp1_;
#line 62 "dictionary.vala"
		e = _inner_error0_;
#line 62 "dictionary.vala"
		_inner_error0_ = NULL;
#line 65 "dictionary.vala"
		_tmp1_ = e->message;
#line 65 "dictionary.vala"
		g_error ("dictionary.vala:65: failed to parse JSON: %s", _tmp1_);
#line 62 "dictionary.vala"
		_g_error_free0 (e);
#line 770 "dictionary.c"
	}
	__finally0:
#line 62 "dictionary.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 62 "dictionary.vala"
		_g_object_unref0 (parser);
#line 62 "dictionary.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 62 "dictionary.vala"
		g_clear_error (&_inner_error0_);
#line 62 "dictionary.vala"
		return;
#line 783 "dictionary.c"
	}
#line 68 "dictionary.vala"
	_tmp2_ = json_parser_get_root (parser);
#line 68 "dictionary.vala"
	_tmp3_ = __vala_JsonNode_copy0 (_tmp2_);
#line 68 "dictionary.vala"
	root = _tmp3_;
#line 70 "dictionary.vala"
	if (json_node_get_node_type (root) != JSON_NODE_ARRAY) {
#line 71 "dictionary.vala"
		g_error ("dictionary.vala:71: malformed format of dictionaries list: toplevel");
#line 795 "dictionary.c"
	}
#line 73 "dictionary.vala"
	_tmp4_ = json_node_get_array (root);
#line 73 "dictionary.vala"
	_tmp5_ = _json_array_ref0 (_tmp4_);
#line 73 "dictionary.vala"
	array = _tmp5_;
#line 803 "dictionary.c"
	{
		gint i = 0;
#line 75 "dictionary.vala"
		i = 0;
#line 808 "dictionary.c"
		{
			gboolean _tmp6_ = FALSE;
#line 75 "dictionary.vala"
			_tmp6_ = TRUE;
#line 75 "dictionary.vala"
			while (TRUE) {
#line 815 "dictionary.c"
				JsonArray* _tmp8_;
				JsonNode* node = NULL;
				JsonArray* _tmp9_;
				JsonNode* _tmp10_;
				JsonNode* _tmp11_;
				JsonNode* _tmp12_;
				JsonObject* object = NULL;
				JsonNode* _tmp13_;
				JsonObject* _tmp14_;
				JsonObject* _tmp15_;
				DictionaryMetadata* metadata = NULL;
				JsonObject* _tmp16_;
				DictionaryMetadata* _tmp17_;
				DictionaryMetadata* _tmp18_;
				const gchar* _tmp19_;
				const gchar* _tmp20_;
#line 75 "dictionary.vala"
				if (!_tmp6_) {
#line 834 "dictionary.c"
					gint _tmp7_;
#line 75 "dictionary.vala"
					_tmp7_ = i;
#line 75 "dictionary.vala"
					i = _tmp7_ + 1;
#line 840 "dictionary.c"
				}
#line 75 "dictionary.vala"
				_tmp6_ = FALSE;
#line 75 "dictionary.vala"
				_tmp8_ = array;
#line 75 "dictionary.vala"
				if (!(((guint) i) < json_array_get_length (_tmp8_))) {
#line 75 "dictionary.vala"
					break;
#line 850 "dictionary.c"
				}
#line 76 "dictionary.vala"
				_tmp9_ = array;
#line 76 "dictionary.vala"
				_tmp10_ = json_array_get_element (_tmp9_, (guint) i);
#line 76 "dictionary.vala"
				_tmp11_ = __vala_JsonNode_copy0 (_tmp10_);
#line 76 "dictionary.vala"
				node = _tmp11_;
#line 78 "dictionary.vala"
				_tmp12_ = node;
#line 78 "dictionary.vala"
				if (json_node_get_node_type (_tmp12_) != JSON_NODE_OBJECT) {
#line 79 "dictionary.vala"
					g_warning ("dictionary.vala:79: malformed format of dictionaries list: child objec" \
"t");
#line 80 "dictionary.vala"
					__vala_JsonNode_free0 (node);
#line 80 "dictionary.vala"
					continue;
#line 870 "dictionary.c"
				}
#line 83 "dictionary.vala"
				_tmp13_ = node;
#line 83 "dictionary.vala"
				_tmp14_ = json_node_get_object (_tmp13_);
#line 83 "dictionary.vala"
				_tmp15_ = _json_object_ref0 (_tmp14_);
#line 83 "dictionary.vala"
				object = _tmp15_;
#line 84 "dictionary.vala"
				_tmp16_ = object;
#line 84 "dictionary.vala"
				_tmp17_ = dictionary_metadata_new_from_json_object (_tmp16_);
#line 84 "dictionary.vala"
				metadata = _tmp17_;
#line 86 "dictionary.vala"
				_tmp18_ = metadata;
#line 86 "dictionary.vala"
				_tmp19_ = dictionary_metadata_get_filename (_tmp18_);
#line 86 "dictionary.vala"
				_tmp20_ = _tmp19_;
#line 86 "dictionary.vala"
				if (g_file_test (_tmp20_, G_FILE_TEST_EXISTS)) {
#line 894 "dictionary.c"
					GeeMap* _tmp21_;
					DictionaryMetadata* _tmp22_;
					const gchar* _tmp23_;
					const gchar* _tmp24_;
					DictionaryMetadata* _tmp25_;
					GeeList* _tmp26_;
					DictionaryMetadata* _tmp27_;
					const gchar* _tmp28_;
					const gchar* _tmp29_;
#line 87 "dictionary.vala"
					_tmp21_ = self->priv->available_metadata;
#line 87 "dictionary.vala"
					_tmp22_ = metadata;
#line 87 "dictionary.vala"
					_tmp23_ = dictionary_metadata_get_id (_tmp22_);
#line 87 "dictionary.vala"
					_tmp24_ = _tmp23_;
#line 87 "dictionary.vala"
					_tmp25_ = metadata;
#line 87 "dictionary.vala"
					gee_map_set (_tmp21_, _tmp24_, _tmp25_);
#line 88 "dictionary.vala"
					_tmp26_ = self->priv->available;
#line 88 "dictionary.vala"
					_tmp27_ = metadata;
#line 88 "dictionary.vala"
					_tmp28_ = dictionary_metadata_get_id (_tmp27_);
#line 88 "dictionary.vala"
					_tmp29_ = _tmp28_;
#line 88 "dictionary.vala"
					gee_collection_add ((GeeCollection*) _tmp26_, _tmp29_);
#line 926 "dictionary.c"
				}
#line 75 "dictionary.vala"
				_g_object_unref0 (metadata);
#line 75 "dictionary.vala"
				_json_object_unref0 (object);
#line 75 "dictionary.vala"
				__vala_JsonNode_free0 (node);
#line 934 "dictionary.c"
			}
		}
	}
#line 60 "dictionary.vala"
	_json_array_unref0 (array);
#line 60 "dictionary.vala"
	__vala_JsonNode_free0 (root);
#line 60 "dictionary.vala"
	_g_object_unref0 (parser);
#line 944 "dictionary.c"
}

DictionaryMetadata**
dictionary_registry_list_available (DictionaryRegistry* self,
                                    gint* result_length1)
{
	GeeArrayList* _result_ = NULL;
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp13_;
	gint _tmp14_ = 0;
	gpointer* _tmp15_;
	DictionaryMetadata** _tmp16_;
	gint _tmp16__length1;
	DictionaryMetadata** result;
#line 93 "dictionary.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 94 "dictionary.vala"
	_tmp0_ = gee_array_list_new (TYPE_DICTIONARY_METADATA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 94 "dictionary.vala"
	_result_ = _tmp0_;
#line 965 "dictionary.c"
	{
		GeeList* _id_list = NULL;
		GeeList* _tmp1_;
		gint _id_size = 0;
		GeeList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _id_index = 0;
#line 95 "dictionary.vala"
		_tmp1_ = self->priv->available;
#line 95 "dictionary.vala"
		_id_list = _tmp1_;
#line 95 "dictionary.vala"
		_tmp2_ = _id_list;
#line 95 "dictionary.vala"
		_tmp3_ = gee_collection_get_size ((GeeCollection*) _tmp2_);
#line 95 "dictionary.vala"
		_tmp4_ = _tmp3_;
#line 95 "dictionary.vala"
		_id_size = _tmp4_;
#line 95 "dictionary.vala"
		_id_index = -1;
#line 95 "dictionary.vala"
		while (TRUE) {
#line 990 "dictionary.c"
			gint _tmp5_;
			gint _tmp6_;
			gchar* id = NULL;
			GeeList* _tmp7_;
			gpointer _tmp8_;
			GeeArrayList* _tmp9_;
			const gchar* _tmp10_;
			DictionaryMetadata* _tmp11_;
			DictionaryMetadata* _tmp12_;
#line 95 "dictionary.vala"
			_id_index = _id_index + 1;
#line 95 "dictionary.vala"
			_tmp5_ = _id_index;
#line 95 "dictionary.vala"
			_tmp6_ = _id_size;
#line 95 "dictionary.vala"
			if (!(_tmp5_ < _tmp6_)) {
#line 95 "dictionary.vala"
				break;
#line 1010 "dictionary.c"
			}
#line 95 "dictionary.vala"
			_tmp7_ = _id_list;
#line 95 "dictionary.vala"
			_tmp8_ = gee_list_get (_tmp7_, _id_index);
#line 95 "dictionary.vala"
			id = (gchar*) _tmp8_;
#line 96 "dictionary.vala"
			_tmp9_ = _result_;
#line 96 "dictionary.vala"
			_tmp10_ = id;
#line 96 "dictionary.vala"
			_tmp11_ = dictionary_registry_get_metadata (self, _tmp10_);
#line 96 "dictionary.vala"
			_tmp12_ = _tmp11_;
#line 96 "dictionary.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp9_, _tmp12_);
#line 96 "dictionary.vala"
			_g_object_unref0 (_tmp12_);
#line 95 "dictionary.vala"
			_g_free0 (id);
#line 1032 "dictionary.c"
		}
	}
#line 98 "dictionary.vala"
	_tmp13_ = _result_;
#line 98 "dictionary.vala"
	_tmp15_ = gee_collection_to_array ((GeeCollection*) _tmp13_, &_tmp14_);
#line 98 "dictionary.vala"
	_tmp16_ = _tmp15_;
#line 98 "dictionary.vala"
	_tmp16__length1 = _tmp14_;
#line 98 "dictionary.vala"
	if (result_length1) {
#line 98 "dictionary.vala"
		*result_length1 = _tmp16__length1;
#line 1047 "dictionary.c"
	}
#line 98 "dictionary.vala"
	result = _tmp16_;
#line 98 "dictionary.vala"
	_g_object_unref0 (_result_);
#line 98 "dictionary.vala"
	return result;
#line 1055 "dictionary.c"
}

DictionaryMetadata*
dictionary_registry_get_metadata (DictionaryRegistry* self,
                                  const gchar* id)
{
	GeeMap* _tmp0_;
	gpointer _tmp1_;
	DictionaryMetadata* result;
#line 101 "dictionary.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 101 "dictionary.vala"
	g_return_val_if_fail (id != NULL, NULL);
#line 102 "dictionary.vala"
	_tmp0_ = self->priv->available_metadata;
#line 102 "dictionary.vala"
	_tmp1_ = gee_map_get (_tmp0_, id);
#line 102 "dictionary.vala"
	result = (DictionaryMetadata*) _tmp1_;
#line 102 "dictionary.vala"
	return result;
#line 1077 "dictionary.c"
}

DictionaryRegistry*
dictionary_registry_construct (GType object_type)
{
	DictionaryRegistry * self = NULL;
	GFile* file = NULL;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	GFile* _tmp5_;
	GFile* _tmp6_;
	GFile* _tmp7_;
	GError* _inner_error0_ = NULL;
#line 105 "dictionary.vala"
	self = (DictionaryRegistry*) g_object_new (object_type, NULL);
#line 1094 "dictionary.c"
	{
		GInputStream* stream = NULL;
		GInputStream* _tmp0_;
#line 107 "dictionary.vala"
		_tmp0_ = g_resources_open_stream ("/org/freedesktop/ibus/engine/kkc/dictionaries.json", G_RESOURCE_LOOKUP_FLAGS_NONE, &_inner_error0_);
#line 107 "dictionary.vala"
		stream = _tmp0_;
#line 107 "dictionary.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1104 "dictionary.c"
			goto __catch0_g_error;
		}
#line 110 "dictionary.vala"
		dictionary_registry_load_metadata_from_stream (self, stream);
#line 106 "dictionary.vala"
		_g_object_unref0 (stream);
#line 1111 "dictionary.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp1_;
#line 106 "dictionary.vala"
		e = _inner_error0_;
#line 106 "dictionary.vala"
		_inner_error0_ = NULL;
#line 112 "dictionary.vala"
		_tmp1_ = e->message;
#line 112 "dictionary.vala"
		g_error ("dictionary.vala:112: can't load dictionaries list from resource: %s", _tmp1_);
#line 106 "dictionary.vala"
		_g_error_free0 (e);
#line 1128 "dictionary.c"
	}
	__finally0:
#line 106 "dictionary.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 106 "dictionary.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 106 "dictionary.vala"
		g_clear_error (&_inner_error0_);
#line 106 "dictionary.vala"
		return NULL;
#line 1139 "dictionary.c"
	}
#line 115 "dictionary.vala"
	_tmp2_ = g_get_user_config_dir ();
#line 115 "dictionary.vala"
	_tmp3_ = g_build_filename (_tmp2_, PACKAGE_NAME, "dictionaries.json", NULL);
#line 115 "dictionary.vala"
	_tmp4_ = _tmp3_;
#line 115 "dictionary.vala"
	_tmp5_ = g_file_new_for_path (_tmp4_);
#line 115 "dictionary.vala"
	_tmp6_ = _tmp5_;
#line 115 "dictionary.vala"
	_g_free0 (_tmp4_);
#line 115 "dictionary.vala"
	file = _tmp6_;
#line 119 "dictionary.vala"
	_tmp7_ = file;
#line 119 "dictionary.vala"
	if (g_file_query_exists (_tmp7_, NULL)) {
#line 1159 "dictionary.c"
		{
			GFileInputStream* stream = NULL;
			GFile* _tmp8_;
			GFileInputStream* _tmp9_;
			GFileInputStream* _tmp10_;
#line 121 "dictionary.vala"
			_tmp8_ = file;
#line 121 "dictionary.vala"
			_tmp9_ = g_file_read (_tmp8_, NULL, &_inner_error0_);
#line 121 "dictionary.vala"
			stream = _tmp9_;
#line 121 "dictionary.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1173 "dictionary.c"
				goto __catch1_g_error;
			}
#line 122 "dictionary.vala"
			_tmp10_ = stream;
#line 122 "dictionary.vala"
			dictionary_registry_load_metadata_from_stream (self, (GInputStream*) _tmp10_);
#line 120 "dictionary.vala"
			_g_object_unref0 (stream);
#line 1182 "dictionary.c"
		}
		goto __finally1;
		__catch1_g_error:
		{
			GError* e = NULL;
			GFile* _tmp11_;
			gchar* _tmp12_;
			gchar* _tmp13_;
			GError* _tmp14_;
			const gchar* _tmp15_;
#line 120 "dictionary.vala"
			e = _inner_error0_;
#line 120 "dictionary.vala"
			_inner_error0_ = NULL;
#line 124 "dictionary.vala"
			_tmp11_ = file;
#line 124 "dictionary.vala"
			_tmp12_ = g_file_get_path (_tmp11_);
#line 124 "dictionary.vala"
			_tmp13_ = _tmp12_;
#line 124 "dictionary.vala"
			_tmp14_ = e;
#line 124 "dictionary.vala"
			_tmp15_ = _tmp14_->message;
#line 124 "dictionary.vala"
			g_warning ("dictionary.vala:124: %s exists, but cannot read: %s", _tmp13_, _tmp15_);
#line 124 "dictionary.vala"
			_g_free0 (_tmp13_);
#line 120 "dictionary.vala"
			_g_error_free0 (e);
#line 1213 "dictionary.c"
		}
		__finally1:
#line 120 "dictionary.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 120 "dictionary.vala"
			_g_object_unref0 (file);
#line 120 "dictionary.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 120 "dictionary.vala"
			g_clear_error (&_inner_error0_);
#line 120 "dictionary.vala"
			return NULL;
#line 1226 "dictionary.c"
		}
	} else {
		GFile* _tmp16_;
		gchar* _tmp17_;
		gchar* _tmp18_;
#line 129 "dictionary.vala"
		_tmp16_ = file;
#line 129 "dictionary.vala"
		_tmp17_ = g_file_get_path (_tmp16_);
#line 129 "dictionary.vala"
		_tmp18_ = _tmp17_;
#line 129 "dictionary.vala"
		g_warning ("dictionary.vala:129: Dictionary file at %s could not be found. We will" \
" run without any custom dictionaries.", _tmp18_);
#line 129 "dictionary.vala"
		_g_free0 (_tmp18_);
#line 1242 "dictionary.c"
	}
#line 105 "dictionary.vala"
	_g_object_unref0 (file);
#line 105 "dictionary.vala"
	return self;
#line 1248 "dictionary.c"
}

DictionaryRegistry*
dictionary_registry_new (void)
{
#line 105 "dictionary.vala"
	return dictionary_registry_construct (TYPE_DICTIONARY_REGISTRY);
#line 1256 "dictionary.c"
}

static void
dictionary_registry_class_init (DictionaryRegistryClass * klass,
                                gpointer klass_data)
{
#line 55 "dictionary.vala"
	dictionary_registry_parent_class = g_type_class_peek_parent (klass);
#line 55 "dictionary.vala"
	g_type_class_adjust_private_offset (klass, &DictionaryRegistry_private_offset);
#line 55 "dictionary.vala"
	G_OBJECT_CLASS (klass)->finalize = dictionary_registry_finalize;
#line 1269 "dictionary.c"
}

static void
dictionary_registry_instance_init (DictionaryRegistry * self,
                                   gpointer klass)
{
	GeeHashMap* _tmp0_;
	GeeArrayList* _tmp1_;
#line 55 "dictionary.vala"
	self->priv = dictionary_registry_get_instance_private (self);
#line 56 "dictionary.vala"
	_tmp0_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, TYPE_DICTIONARY_METADATA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 56 "dictionary.vala"
	self->priv->available_metadata = (GeeMap*) _tmp0_;
#line 58 "dictionary.vala"
	_tmp1_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 58 "dictionary.vala"
	self->priv->available = (GeeList*) _tmp1_;
#line 1288 "dictionary.c"
}

static void
dictionary_registry_finalize (GObject * obj)
{
	DictionaryRegistry * self;
#line 55 "dictionary.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_DICTIONARY_REGISTRY, DictionaryRegistry);
#line 56 "dictionary.vala"
	_g_object_unref0 (self->priv->available_metadata);
#line 58 "dictionary.vala"
	_g_object_unref0 (self->priv->available);
#line 55 "dictionary.vala"
	G_OBJECT_CLASS (dictionary_registry_parent_class)->finalize (obj);
#line 1303 "dictionary.c"
}

static GType
dictionary_registry_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DictionaryRegistryClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) dictionary_registry_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DictionaryRegistry), 0, (GInstanceInitFunc) dictionary_registry_instance_init, NULL };
	GType dictionary_registry_type_id;
	dictionary_registry_type_id = g_type_register_static (G_TYPE_OBJECT, "DictionaryRegistry", &g_define_type_info, 0);
	DictionaryRegistry_private_offset = g_type_add_instance_private (dictionary_registry_type_id, sizeof (DictionaryRegistryPrivate));
	return dictionary_registry_type_id;
}

GType
dictionary_registry_get_type (void)
{
	static volatile gsize dictionary_registry_type_id__once = 0;
	if (g_once_init_enter (&dictionary_registry_type_id__once)) {
		GType dictionary_registry_type_id;
		dictionary_registry_type_id = dictionary_registry_get_type_once ();
		g_once_init_leave (&dictionary_registry_type_id__once, dictionary_registry_type_id);
	}
	return dictionary_registry_type_id__once;
}

